/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.12 Revision 1.305
1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.305 2015/05/30 16:09:05 mpagano Exp $
4
1# kernel.eclass rewrite for a clean base regarding the 2.6 series of kernel 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
2# with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
3# 7#
4# Author: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
5# Copyright 2004 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
6# 10#
7# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
8# thatll be: johnm
9 12
10# added functionality: 13# added functionality:
11# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
12 15
13# A Couple of env vars are available to effect usage of this eclass 16# A Couple of env vars are available to effect usage of this eclass
14# These are as follows: 17# These are as follows:
15# 18#
19# K_USEPV - When setting the EXTRAVERSION variable, it should
20# add PV to the end.
21# this is useful for thigns like wolk. IE:
22# EXTRAVERSION would be something like : -wolk-4.19-r1
16# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be automatically set within the kernel Makefile 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile
17# K_NOUSENAME - if this is set then EXTRAVERSION will not include the first part of ${PN} in EXTRAVERSION 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
18# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, ck-sources, ac-sources) it will use PR (ie: -r5) as the patchset version for EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
30# ck-sources, ac-sources) it will use PR (ie: -r5) as
31# the patchset version for
19# - and not use it as a true package revision 32# and not use it as a true package revision
20# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in postinst and can be used to carry additional postinst messages 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
34# postinst and can be used to carry additional postinst
35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
21# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
22 38# K_SYMLINK - if this is set, then forcably create symlink anyway
39#
40# K_BASE_VER - for git-sources, declare the base version this patch is
41# based off of.
42# K_DEFCONFIG - Allow specifying a different defconfig target.
43# If length zero, defaults to "defconfig".
44# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
45# combination of "base", "extras" or "experimental".
46# K_EXP_GENPATCHES_PULL - If set, we pull "experimental" regardless of the USE FLAG
47# but expect the ebuild maintainer to use K_EXP_GENPATCHES_LIST.
48# K_EXP_GENPATCHES_NOUSE - If set, no USE flag will be provided for "experimental";
49# as a result the user cannot choose to apply those patches.
50# K_EXP_GENPATCHES_LIST - A list of patches to pick from "experimental" to apply when
51# the USE flag is unset and K_EXP_GENPATCHES_PULL is set.
52# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
53# A value of "5" would apply genpatches-2.6.12-5 to
54# my-sources-2.6.12.ebuild
55# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
56# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
57# code. If empty, will be set to "1" if deblobbing is
58# possible. Test ONLY for "1".
59# K_DEBLOB_TAG - This will be the version of deblob script. It's a upstream SVN tag
60# such asw -gnu or -gnu1.
61# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
62# If false, either optional deblobbing will be available
63# or the license will note the inclusion of freedist
64# code.
65# K_LONGTERM - If set, the eclass will search for the kernel source
66# in the long term directories on the upstream servers
67# as the location has been changed by upstream
23# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which can be supported by the headers ebuild 68# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
69# can be supported by the headers ebuild
24 70
25# UNIPATCH_LIST - space delimetered list of patches to be applied to the kernel 71# UNIPATCH_LIST - space delimetered list of patches to be applied to the
72# kernel
73# UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
74# on "<passedstring>*" and not "<passedno#>_*"
75# - this should _NOT_ be used from the ebuild as this is
76# reserved for end users passing excludes from the cli
26# UNIPATCH_DOCS - space delimemeted list of docs to be installed to the doc dir 77# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
78# the doc dir
79# UNIPATCH_STRICTORDER - if this is set places patches into directories of
80# order, so they are applied in the order passed
27 81
28ECLASS="kernel-2" 82# Changing any other variable in this eclass is not supported; you can request
83# for additional variables to be added by contacting the current maintainer.
84# If you do change them, there is a chance that we will not fix resulting bugs;
85# that of course does not mean we're not willing to help.
86
87PYTHON_COMPAT=( python{2_6,2_7} )
88
89inherit eutils toolchain-funcs versionator multilib python-any-r1
29EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst 90EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
30 91
92# Added by Daniel Ostrow <dostrow@gentoo.org>
93# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
94# I will remove it when I come up with something more reasonable.
95[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
96
97export CTARGET=${CTARGET:-${CHOST}}
98if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
99 export CTARGET=${CATEGORY/cross-}
100fi
101
31HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 102HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
32LICENSE="GPL-2" 103: ${LICENSE:="GPL-2"}
33IUSE="${IUSE} build"
34SLOT="${KV}"
35 104
105# This is the latest KV_PATCH of the deblob tool available from the
106# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
107# for ALL kernel-2 consumer packages where deblob is available.
108: ${DEBLOB_MAX_VERSION:=38}
109
110# No need to run scanelf/strip on kernel sources/headers (bug #134453).
111RESTRICT="binchecks strip"
112
113# set LINUX_HOSTCFLAGS if not already set
114: ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
115
116# debugging functions
117#==============================================================
118# this function exists only to help debug kernel-2.eclass
119# if you are adding new functionality in, put a call to it
120# at the start of src_unpack, or during SRC_URI/dep generation.
121debug-print-kernel2-variables() {
122 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
123 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
124 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
125 debug-print "${v}: ${!v}"
126 done
127}
128
129#Eclass functions only from here onwards ...
130#==============================================================
131handle_genpatches() {
132 local tarball
133 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
134
135 debug-print "Inside handle_genpatches"
136 local OKV_ARRAY
137 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
138
139 # for > 3.0 kernels, handle genpatches tarball name
140 # genpatches for 3.0 and 3.0.1 might be named
141 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
142 # respectively. Handle this.
143
144 for i in ${K_WANT_GENPATCHES} ; do
145 if [[ ${KV_MAJOR} -ge 3 ]]; then
146 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
147 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
148 else
149 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
150 fi
151 else
152 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
153 fi
154
155 local use_cond_start="" use_cond_end=""
156
157 if [[ "${i}" == "experimental" && -z ${K_EXP_GENPATCHES_PULL} && -z ${K_EXP_GENPATCHES_NOUSE} ]] ; then
158 use_cond_start="experimental? ( "
159 use_cond_end=" )"
160
161 if use experimental ; then
162 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
163 debug-print "genpatches tarball: $tarball"
164 fi
165 else
166 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
167 debug-print "genpatches tarball: $tarball"
168 fi
169 GENPATCHES_URI+=" ${use_cond_start}mirror://gentoo/${tarball}${use_cond_end}"
170 done
171}
172
173detect_version() {
174 # this function will detect and set
175 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
176 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
177 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
178
179 # We've already run, so nothing to do here.
180 [[ -n ${KV_FULL} ]] && return 0
181
182 # CKV is used as a comparison kernel version, which is used when
183 # PV doesnt reflect the genuine kernel version.
184 # this gets set to the portage style versioning. ie:
185 # CKV=2.6.11_rc4
186 CKV=${CKV:-${PV}}
187 OKV=${OKV:-${CKV}}
188 OKV=${OKV/_beta/-test}
189 OKV=${OKV/_rc/-rc}
190 OKV=${OKV/-r*}
191 OKV=${OKV/_p*}
192
193 KV_MAJOR=$(get_version_component_range 1 ${OKV})
194 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
195 local OKV_ARRAY
196 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
197
198 # if KV_MAJOR >= 3, then we have no more KV_MINOR
199 #if [[ ${KV_MAJOR} -lt 3 ]]; then
200 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
201 KV_MINOR=$(get_version_component_range 2 ${OKV})
202 KV_PATCH=$(get_version_component_range 3 ${OKV})
203 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
204 KV_EXTRA=$(get_version_component_range 4- ${OKV})
205 KV_EXTRA=${KV_EXTRA/[-_]*}
206 else
207 KV_PATCH=$(get_version_component_range 3- ${OKV})
208 fi
209 else
210 KV_PATCH=$(get_version_component_range 2 ${OKV})
211 KV_EXTRA=$(get_version_component_range 3- ${OKV})
212 KV_EXTRA=${KV_EXTRA/[-_]*}
213 fi
214
215 debug-print "KV_EXTRA is ${KV_EXTRA}"
216
217 KV_PATCH=${KV_PATCH/[-_]*}
218
219 local v n=0 missing
220 #if [[ ${KV_MAJOR} -lt 3 ]]; then
221 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
222 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
223 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
224 done
225 else
226 for v in CKV OKV KV_{MAJOR,PATCH} ; do
227 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
228 done
229 fi
230
231 [[ $n -eq 1 ]] && \
232 eerror "Missing variables: ${missing}" && \
233 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
234 unset v n missing
235
236# if [[ ${KV_MAJOR} -ge 3 ]]; then
237 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
238 KV_PATCH_ARR=(${KV_PATCH//\./ })
239
240 # at this point 031412, Linus is putting all 3.x kernels in a
241 # 3.x directory, may need to revisit when 4.x is released
242 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
243
244 [[ -n "${K_LONGTERM}" ]] &&
245 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
246 else
247 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
248 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
249 if [[ ${KV_MAJOR} -ge 3 ]]; then
250 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
251 else
252 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
253 fi
254
255 [[ -n "${K_LONGTERM}" ]] &&
256 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
257 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
258 fi
259
260 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
261
262 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
263 # handle non genpatch using sources correctly
264 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
265 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
266 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
267 fi
268 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
269 else
270 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
271 fi
272
273 RELEASE=${CKV/${OKV}}
274 RELEASE=${RELEASE/_beta}
275 RELEASE=${RELEASE/_rc/-rc}
276 RELEASE=${RELEASE/_pre/-pre}
277 # We cannot trivally call kernel_is here, because it calls us to detect the
278 # version
279 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
280 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
281 RELEASETYPE=${RELEASE//[0-9]}
282
283 # Now we know that RELEASE is the -rc/-git
284 # and RELEASETYPE is the same but with its numerics stripped
285 # we can work on better sorting EXTRAVERSION.
286 # first of all, we add the release
287 EXTRAVERSION="${RELEASE}"
288 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
289 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
290
291 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
292 if [[ -n "${K_NOUSEPR}" ]]; then
293 # Don't add anything based on PR to EXTRAVERSION
294 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
295 elif [[ -n ${K_PREPATCHED} ]]; then
296 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
297 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
298 elif [[ "${ETYPE}" = "sources" ]]; then
299 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
300 # For some sources we want to use the PV in the extra version
301 # This is because upstream releases with a completely different
302 # versioning scheme.
303 case ${PN/-*} in
304 wolk) K_USEPV=1;;
305 vserver) K_USEPV=1;;
306 esac
307
308 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
309 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
310 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
311 fi
312 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
313
314 # The only messing around which should actually effect this is for KV_EXTRA
315 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
316 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
317
318 if [[ -n ${KV_EXTRA} ]]; then
319 if [[ -n ${KV_MINOR} ]]; then
320 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
321 else
322 OKV="${KV_MAJOR}.${KV_PATCH}"
323 fi
324 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
325 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
326 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
327 fi
328
329 # We need to set this using OKV, but we need to set it before we do any
330 # messing around with OKV based on RELEASETYPE
331 KV_FULL=${OKV}${EXTRAVERSION}
332
333 # we will set this for backwards compatibility.
334 S=${WORKDIR}/linux-${KV_FULL}
335 KV=${KV_FULL}
336
337 # -rc-git pulls can be achieved by specifying CKV
338 # for example:
339 # CKV="2.6.11_rc3_pre2"
340 # will pull:
341 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
342
343 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
344
345 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
346 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
347 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
348 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
349 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
350 fi
351
352 if [[ ${RELEASETYPE} == -git ]]; then
353 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
354 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
355 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
356 fi
357
358 if [[ ${RELEASETYPE} == -rc-git ]]; then
359 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
360 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
361 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
362 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
363
364 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
365 fi
366 else
367 KV_PATCH_ARR=(${KV_PATCH//\./ })
368
369 # the different majorminor versions have different patch start versions
370 OKV_DICT=(["2"]="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))" ["3"]="2.6.39" ["4"]="3.19")
371
372 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
373 OKV=${K_BASE_VER:-$OKV_DICT["${KV_MAJOR}"]}
374 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
375 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
376 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
377 fi
378
379 if [[ ${RELEASETYPE} == -git ]]; then
380 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
381 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
382 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
383 fi
384
385 if [[ ${RELEASETYPE} == -rc-git ]]; then
386 OKV=${K_BASE_VER:-$OKV_DICT["${KV_MAJOR}"]}
387 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
388 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
389 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
390
391 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
392 fi
393
394
395 fi
396
397 debug-print-kernel2-variables
398
399 handle_genpatches
400}
401
402# Note: duplicated in linux-info.eclass
403kernel_is() {
404 # ALL of these should be set before we can safely continue this function.
405 # some of the sources have in the past had only one set.
406 local v n=0
407 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
408 [[ $n -eq 1 ]] && detect_version
409 unset v n
410
411 # Now we can continue
412 local operator test value
413
414 case ${1#-} in
415 lt) operator="-lt"; shift;;
416 gt) operator="-gt"; shift;;
417 le) operator="-le"; shift;;
418 ge) operator="-ge"; shift;;
419 eq) operator="-eq"; shift;;
420 *) operator="-eq";;
421 esac
422 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
423
424 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
425 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
426 [ ${test} ${operator} ${value} ]
427}
428
429kernel_is_2_4() {
430 kernel_is 2 4
431}
432
433kernel_is_2_6() {
434 kernel_is 2 6 || kernel_is 2 5
435}
436
36# capture the sources type and set depends 437# Capture the sources type and set DEPENDs
37if [ "${ETYPE}" == "sources" ] 438if [[ ${ETYPE} == sources ]]; then
38then 439 DEPEND="!build? (
39 #console-tools is needed to solve the loadkeys fiasco; binutils version needed to avoid Athlon/PIII/SSE assembler bugs. 440 sys-apps/sed
40 DEPEND="!build? ( sys-apps/sed
41 >=sys-devel/binutils-2.11.90.0.31 )" 441 >=sys-devel/binutils-2.11.90.0.31
42 442 )"
43 RDEPEND="${DEPEND} 443 RDEPEND="!build? (
44 !build? ( >=sys-libs/ncurses-5.2 444 >=sys-libs/ncurses-5.2
445 sys-devel/make
45 dev-lang/perl 446 dev-lang/perl
46 sys-apps/module-init-tools 447 sys-devel/bc
47 sys-devel/make )" 448 )"
48 449
49 PROVIDE="virtual/linux-sources virtual/alsa" 450 SLOT="${PVR}"
451 DESCRIPTION="Sources based on the Linux Kernel."
452 IUSE="symlink build"
50 453
454 # Bug #266157, deblob for libre support
455 if [[ -z ${K_PREDEBLOBBED} ]] ; then
456 # Bug #359865, force a call to detect_version if needed
457 kernel_is ge 2 6 27 && \
458 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
459 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
460 K_DEBLOB_AVAILABLE=1
461 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
462 IUSE="${IUSE} deblob"
463
464 # Reflect that kernels contain firmware blobs unless otherwise
465 # stripped
466 LICENSE="${LICENSE} !deblob? ( freedist )"
467
468 DEPEND+=" deblob? ( ${PYTHON_DEPS} )"
469
470 if [[ -n KV_MINOR ]]; then
471 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
472 else
473 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
474 fi
475
476 if [[ ${KV_MAJOR} -ge 3 ]]; then
477 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
478 fi
479
480 # deblob svn tag, default is -gnu, to change, use K_DEBLOB_TAG in ebuild
481 K_DEBLOB_TAG=${K_DEBLOB_TAG:--gnu}
482 DEBLOB_A="deblob-${DEBLOB_PV}"
483 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
484 DEBLOB_HOMEPAGE="http://www.fsfla.org/svn/fsfla/software/linux-libre/releases/tags"
485 DEBLOB_URI_PATH="${DEBLOB_PV}${K_DEBLOB_TAG}"
486 if ! has "${EAPI:-0}" 0 1 ; then
487 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
488 else
489 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
490 fi
491
492 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
493 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
494
495 KERNEL_URI="${KERNEL_URI}
496 deblob? (
497 ${DEBLOB_URI}
498 ${DEBLOB_CHECK_URI}
499 )"
500 else
501 # We have no way to deblob older kernels, so just mark them as
502 # tainted with non-libre materials.
503 LICENSE="${LICENSE} freedist"
504 fi
505 fi
506
51elif [ "${ETYPE}" == "headers" ] 507elif [[ ${ETYPE} == headers ]]; then
52then 508 DESCRIPTION="Linux system headers"
53 PROVIDE="virtual/kernel virtual/os-headers" 509
510 # Since we should NOT honour KBUILD_OUTPUT in headers
511 # lets unset it here.
512 unset KBUILD_OUTPUT
513
514 SLOT="0"
54else 515else
55 eerror "Unknown ETYPE=\"${ETYPE}\", must be either \"sources\" or \"headers\"" 516 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
56 die 517 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
57fi 518fi
58 519
59# Grab kernel version from KV 520# Cross-compile support functions
60KV_MAJOR=$(echo ${KV} | cut -d. -f1)
61KV_MINOR=$(echo ${KV} | cut -d. -f2)
62KV_PATCH=$(echo ${KV} | cut -d. -f3)
63KV_PATCH=${KV_PATCH/[-_]*/}
64
65# set LINUX_HOSTCFLAGS if not already set
66[ -z "$LINUX_HOSTCFLAGS" ] && LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
67
68
69#eclass functions only from here onwards.
70#============================================================== 521#==============================================================
71kernel_is_2_4() { 522kernel_header_destdir() {
72 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 4 ] && return 0 || return 1 523 [[ ${CTARGET} == ${CHOST} ]] \
524 && echo /usr/include \
525 || echo /usr/${CTARGET}/usr/include
73} 526}
74 527
75kernel_is_2_6() { 528cross_pre_c_headers() {
76 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -eq 5 -o ${KV_MINOR} -eq 6 ] && return 0 || return 1 529 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
77} 530}
78 531
532env_setup_xmakeopts() {
533 # Kernel ARCH != portage ARCH
534 export KARCH=$(tc-arch-kernel)
535
536 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
537 # variables properly or bad things happen !
538 xmakeopts="ARCH=${KARCH}"
539 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
540 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
541 elif type -p ${CHOST}-ar > /dev/null ; then
542 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
543 fi
544 export xmakeopts
545}
79 546
80# Unpack functions 547# Unpack functions
81#============================================================== 548#==============================================================
82unpack_2_4() { 549unpack_2_4() {
83 cd ${S}
84 # this file is required for other things to build properly, 550 # this file is required for other things to build properly,
85 # so we autogenerate it 551 # so we autogenerate it
86 make mrproper || die "make mrproper died" 552 make -s mrproper ${xmakeopts} || die "make mrproper failed"
553 make -s symlinks ${xmakeopts} || die "make symlinks failed"
87 make include/linux/version.h || die "make include/linux/version.h failed" 554 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
88 echo ">>> version.h compiled successfully." 555 echo ">>> version.h compiled successfully."
89} 556}
90 557
558unpack_2_6() {
559 # this file is required for other things to build properly, so we
560 # autogenerate it ... generate a .config to keep version.h build from
561 # spitting out an annoying warning
562 make -s mrproper ${xmakeopts} 2>/dev/null \
563 || die "make mrproper failed"
564
565 # quick fix for bug #132152 which triggers when it cannot include linux
566 # headers (ie, we have not installed it yet)
567 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
568 touch .config
569 eerror "make defconfig failed."
570 eerror "assuming you dont have any headers installed yet and continuing"
571 epause 5
572 fi
573
574 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
575 || die "make include/linux/version.h failed"
576 rm -f .config >/dev/null
577}
578
91universal_unpack() { 579universal_unpack() {
580 debug-print "Inside universal_unpack"
581
582 local OKV_ARRAY
583 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
584
585 cd "${WORKDIR}"
586 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
587 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
588 else
589 unpack linux-${OKV}.tar.xz
590 fi
591
592 if [[ -d "linux" ]]; then
593 debug-print "Moving linux to linux-${KV_FULL}"
594 mv linux linux-${KV_FULL} \
595 || die "Unable to move source tree to ${KV_FULL}."
596 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
597 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
598 [[ "${ETYPE}" = "sources" ]]; then
599 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
600 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
601 || die "Unable to move source tree to ${KV_FULL}."
602 else
603 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
604 mv linux-${OKV} linux-${KV_FULL} \
605 || die "Unable to move source tree to ${KV_FULL}."
606 fi
607 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
608 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
609 || die "Unable to move source tree to ${KV_FULL}."
610 fi
611 cd "${S}"
612
92 # remove all backup files 613 # remove all backup files
93 find . -iname "*~" -exec rm {} \; 2> /dev/null 614 find . -iname "*~" -exec rm {} \; 2> /dev/null
94 615
95 if [ -d "${S}/Documentation/DocBook" ]
96 then
97 cd ${S}/Documentation/DocBook
98 sed -e "s:db2:docbook2:g" Makefile > Makefile.new \
99 && mv Makefile.new Makefile
100 cd ${S}
101 fi
102} 616}
103 617
104unpack_set_extraversion() { 618unpack_set_extraversion() {
105 # Gentoo Linux uses /boot, so fix 'make install' to work properly and fix EXTRAVERSION
106 cd ${S} 619 cd "${S}"
107 mv Makefile Makefile.orig 620 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
621 cd "${OLDPWD}"
622}
623
624# Should be done after patches have been applied
625# Otherwise patches that modify the same area of Makefile will fail
626unpack_fix_install_path() {
627 cd "${S}"
108 sed -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' \ 628 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
109 -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" \
110 Makefile.orig > Makefile
111 rm Makefile.orig
112} 629}
113 630
114# Compile Functions 631# Compile Functions
115#============================================================== 632#==============================================================
116compile_headers() { 633compile_headers() {
117 local MY_ARCH 634 env_setup_xmakeopts
118 635
119 MY_ARCH=${ARCH} 636 # if we couldnt obtain HOSTCFLAGS from the Makefile,
120 unset ${ARCH} 637 # then set it to something sane
638 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
639 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
640
641 if kernel_is 2 4; then
121 yes "" | make oldconfig 642 yes "" | make oldconfig ${xmakeopts}
122 echo ">>> make oldconfig complete" 643 echo ">>> make oldconfig complete"
123 ARCH=${MY_ARCH} 644 make dep ${xmakeopts}
645 elif kernel_is 2 6; then
646 # 2.6.18 introduces headers_install which means we dont need any
647 # of this crap anymore :D
648 kernel_is ge 2 6 18 && return 0
649
650 # autoconf.h isnt generated unless it already exists. plus, we have
651 # no guarantee that any headers are installed on the system...
652 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
653 || touch include/linux/autoconf.h
654
655 # if K_DEFCONFIG isn't set, force to "defconfig"
656 # needed by mips
657 if [[ -z ${K_DEFCONFIG} ]]; then
658 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
659 case ${CTARGET} in
660 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
661 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
662 *) K_DEFCONFIG="defconfig";;
663 esac
664 else
665 K_DEFCONFIG="defconfig"
666 fi
667 fi
668
669 # if there arent any installed headers, then there also isnt an asm
670 # symlink in /usr/include/, and make defconfig will fail, so we have
671 # to force an include path with $S.
672 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
673 ln -sf asm-${KARCH} "${S}"/include/asm
674 cross_pre_c_headers && return 0
675
676 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
677 if compile_headers_tweak_config ; then
678 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
679 fi
680 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
681 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
682 fi
683}
684
685compile_headers_tweak_config() {
686 # some targets can be very very picky, so let's finesse the
687 # .config based upon any info we may have
688 case ${CTARGET} in
689 sh*)
690 sed -i '/CONFIG_CPU_SH/d' .config
691 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
692 return 0;;
693 esac
694
695 # no changes, so lets do nothing
696 return 1
124} 697}
125 698
126# install functions 699# install functions
127#============================================================== 700#==============================================================
128install_universal() { 701install_universal() {
129 #fix silly permissions in tarball 702 # Fix silly permissions in tarball
130 cd ${WORKDIR} 703 cd "${WORKDIR}"
131 chown -R root:root * 704 chown -R 0:0 * >& /dev/null
132 chmod -R a+r-w+X,u+w * 705 chmod -R a+r-w+X,u+w *
706 cd ${OLDPWD}
133} 707}
134 708
135install_headers() { 709install_headers() {
136 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 710 local ddir=$(kernel_header_destdir)
137 [ $(kernel_is_2_6) $? == 0 ] && ln -sf ${S}/include/asm-${ARCH} ${S}/include/asm
138 711
139 cd ${S} 712 # 2.6.18 introduces headers_install which means we dont need any
140 dodir /usr/include/linux 713 # of this crap anymore :D
141 cp -ax ${S}/include/linux/* ${D}/usr/include/linux 714 if kernel_is ge 2 6 18 ; then
715 env_setup_xmakeopts
716 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
717
718 # let other packages install some of these headers
719 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
720 return 0
721 fi
722
723 # Do not use "linux/*" as that can cause problems with very long
724 # $S values where the cmdline to cp is too long
725 pushd "${S}" >/dev/null
726 dodir ${ddir}/linux
727 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
142 rm -rf ${D}/usr/include/linux/modules 728 rm -rf "${D}"/${ddir}/linux/modules
143 dodir /usr/include/asm 729
144 cp -ax ${S}/include/asm/* ${D}/usr/include/asm 730 dodir ${ddir}/asm
145 731 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
146 if [ $(kernel_is_2_6) $? == 0 ] 732
147 then 733 if kernel_is 2 6 ; then
148 dodir /usr/include/asm-generic 734 dodir ${ddir}/asm-generic
149 cp -ax ${S}/include/asm-generic/* ${D}/usr/include/asm-generic 735 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
150 fi 736 fi
737
738 # clean up
739 find "${D}" -name '*.orig' -exec rm -f {} \;
740
741 popd >/dev/null
151} 742}
152 743
153install_sources() { 744install_sources() {
154 local doc 745 local file
155 local docs
156 746
157 cd ${S} 747 cd "${S}"
158 dodir /usr/src 748 dodir /usr/src
159 echo ">>> Copying sources..." 749 echo ">>> Copying sources ..."
160 if [ -d "${WORKDIR}/${KV}/docs/" ] 750
161 then 751 file="$(find ${WORKDIR} -iname "docs" -type d)"
162 for file in $(ls -1 ${WORKDIR}/${KV}/docs/) 752 if [[ -n ${file} ]]; then
163 do 753 for file in $(find ${file} -type f); do
164 echo "XX_${file}*" >> ${S}/patches.txt 754 echo "${file//*docs\/}" >> "${S}"/patches.txt
165 cat ${WORKDIR}/${KV}/docs/${file} >> ${S}/patches.txt 755 echo "===================================================" >> "${S}"/patches.txt
756 cat ${file} >> "${S}"/patches.txt
757 echo "===================================================" >> "${S}"/patches.txt
166 echo "" >> ${S}/patches.txt 758 echo "" >> "${S}"/patches.txt
167 done 759 done
168 fi 760 fi
169 761
170 if [ ! -f ${S}/patches.txt ] 762 if [[ ! -f ${S}/patches.txt ]]; then
171 then
172 # patches.txt is empty so lets use our ChangeLog 763 # patches.txt is empty so lets use our ChangeLog
173 [ -f ${FILESDIR}/../ChangeLog ] && echo "Please check the ebuild ChangeLog for more details." > ${S}/patches.txt 764 [[ -f ${FILESDIR}/../ChangeLog ]] && \
765 echo "Please check the ebuild ChangeLog for more details." \
766 > "${S}"/patches.txt
174 fi 767 fi
175 768
176 for doc in ${UNIPATCH_DOCS}
177 do
178 [ -f ${doc} ] && docs="${docs} ${doc}"
179 done
180
181 if [ -f ${S}/patches.txt ]; then
182 docs="${docs} ${S}/patches.txt"
183 fi
184 dodoc ${docs}
185 mv ${WORKDIR}/linux* ${D}/usr/src 769 mv ${WORKDIR}/linux* "${D}"/usr/src
770
771 if [[ -n "${UNIPATCH_DOCS}" ]] ; then
772 for i in ${UNIPATCH_DOCS}; do
773 dodoc "${T}"/${i}
774 done
775 fi
186} 776}
187 777
188# pkg_preinst functions 778# pkg_preinst functions
189#============================================================== 779#==============================================================
190preinst_headers() { 780preinst_headers() {
191 [ -L ${ROOT}usr/include/linux ] && rm ${ROOT}usr/include/linux 781 local ddir=$(kernel_header_destdir)
192 [ -L ${ROOT}usr/include/asm ] && rm ${ROOT}usr/include/asm 782 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
783 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
193} 784}
194 785
195# pkg_postinst functions 786# pkg_postinst functions
196#============================================================== 787#==============================================================
197postinst_sources() { 788postinst_sources() {
198 if [ ! -h ${ROOT}usr/src/linux ] 789 local MAKELINK=0
199 then 790
791 # if we have USE=symlink, then force K_SYMLINK=1
792 use symlink && K_SYMLINK=1
793
794 # if we're using a deblobbed kernel, it's not supported
795 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
796 use deblob && \
797 K_SECURITY_UNSUPPORTED=deblob
798
799 # if we are to forcably symlink, delete it if it already exists first.
800 if [[ ${K_SYMLINK} > 0 ]]; then
200 ln -sf ${ROOT}usr/src/linux-${KV} ${ROOT}usr/src/linux 801 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
802 MAKELINK=1
803 fi
804
805 # if the link doesnt exist, lets create it
806 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
807
808 if [[ ${MAKELINK} == 1 ]]; then
809 cd "${ROOT}"usr/src
810 ln -sf linux-${KV_FULL} linux
811 cd ${OLDPWD}
201 fi 812 fi
202 813
203 # Don't forget to make directory for sysfs 814 # Don't forget to make directory for sysfs
204 [ ! -d "${ROOT}/sys" -a $(kernel_is_2_6) $? == 0 ] && mkdir /sys 815 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
205 816
206 echo 817 echo
207 einfo "After installing a new kernel of any version, it is important" 818 elog "If you are upgrading from a previous kernel, you may be interested"
208 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y" 819 elog "in the following document:"
209 einfo "created (X.Y is the first 2 parts of your new kernel version)" 820 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
210 echo 821 echo
211 einfo "For example, this kernel will require:" 822
212 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
213 echo
214
215 # if K_EXTRAEINFO is set then lets display it now 823 # if K_EXTRAEINFO is set then lets display it now
216 if [ -n "${K_EXTRAEINFO}" ] 824 if [[ -n ${K_EXTRAEINFO} ]]; then
217 then
218 echo ${K_EXTRAEINFO} | fmt | 825 echo ${K_EXTRAEINFO} | fmt |
219 while read -s ELINE 826 while read -s ELINE; do einfo "${ELINE}"; done
220 do 827 fi
221 einfo "${ELINE}"
222 done
223 828
224 echo 829 # if K_EXTRAELOG is set then lets display it now
830 if [[ -n ${K_EXTRAELOG} ]]; then
831 echo ${K_EXTRAELOG} | fmt |
832 while read -s ELINE; do elog "${ELINE}"; done
225 fi 833 fi
226 834
227 # if K_EXTRAEWARN is set then lets display it now 835 # if K_EXTRAEWARN is set then lets display it now
228 if [ -n "${K_EXTRAEWARN}" ] 836 if [[ -n ${K_EXTRAEWARN} ]]; then
229 then
230 echo ${K_EXTRAEWARN} | fmt | 837 echo ${K_EXTRAEWARN} | fmt |
231 while read -s ELINE 838 while read -s ELINE; do ewarn "${ELINE}"; done
232 do 839 fi
233 ewarn "${ELINE}"
234 done
235 840
841 # optionally display security unsupported message
842 # Start with why
843 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
844 ewarn "Deblobbed kernels may not be up-to-date security-wise"
845 ewarn "as they depend on external scripts."
846 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
847 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
848 fi
849 # And now the general message.
850 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
851 ewarn "This means that it is likely to be vulnerable to recent security issues."
852 ewarn "For specific information on why this kernel is unsupported, please read:"
853 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
854 fi
855
856 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
857 KV_MAJOR=$(get_version_component_range 1 ${OKV})
858 KV_MINOR=$(get_version_component_range 2 ${OKV})
859 KV_PATCH=$(get_version_component_range 3 ${OKV})
860 if [[ "$(tc-arch)" = "sparc" ]]; then
861 if [[ $(gcc-major-version) -lt 4 && $(gcc-minor-version) -lt 4 ]]; then
862 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]] ; then
236 echo 863 echo
864 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
865 elog "you now need to do"
866 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
867 elog "instead of just"
868 elog " make"
869 elog "to compile the kernel. For more information please browse to"
870 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
871 echo
872 fi
237 fi 873 fi
238} 874 fi
239
240postinst_headers() {
241 echo
242 einfo "Kernel headers are usually only used when recompiling glibc."
243 einfo "Following the installation of newer headers it is advised that"
244 einfo "you re-merge glibc as follows:"
245 einfo "# emerge glibc"
246 einfo "Failure to do so will cause glibc to not make use of newer"
247 einfo "features present in the updated kernelheaders."
248 echo
249} 875}
250 876
251# pkg_setup functions 877# pkg_setup functions
252#============================================================== 878#==============================================================
253setup_headers() { 879setup_headers() {
254 ARCH=$(uname -m | sed -e s/[i].86/i386/ -e s/x86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ -e s/amd64/x86_64/)
255 [ "$ARCH" == "sparc" -a "$PROFILE_ARCH" == "sparc64" ] && ARCH="sparc64"
256
257 [ -z "${H_SUPPORTEDARCH}" ] && H_SUPPORTEDARCH="${PN/-*/}" 880 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
258 for i in ${H_SUPPORTEDARCH} 881 for i in ${H_SUPPORTEDARCH}; do
259 do
260 [ "${ARCH}" == "${i}" ] && H_ACCEPT_ARCH="yes" 882 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
261 done 883 done
262 884
263 if [ "${H_ACCEPT_ARCH}" != "yes" ] 885 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
264 then
265 echo 886 echo
266 eerror "This version of ${PN} does not support ${ARCH}." 887 eerror "This version of ${PN} does not support $(tc-arch)."
267 eerror "Please merge the appropriate sources, in most cases" 888 eerror "Please merge the appropriate sources, in most cases"
268 eerror "this will be ${ARCH}-headers." 889 eerror "(but not all) this will be called $(tc-arch)-headers."
269 die "incorrect headers" 890 die "Package unsupported for $(tc-arch)"
270 fi 891 fi
271} 892}
272 893
273# unipatch 894# unipatch
274#============================================================== 895#==============================================================
275unipatch() { 896unipatch() {
276 local i 897 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
277 local x 898 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
278 local extention 899
279 local PIPE_CMD 900 # set to a standard locale to ensure sorts are ordered properly.
280 local UNIPATCH_EXCLUDE 901 myLC_ALL="${LC_ALL}"
281 local KPATCH_DIR 902 myLANG="${LANG}"
282 local PATCH_DEPTH 903 LC_ALL="C"
283 local ELINE 904 LANG=""
284 905
285 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 906 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
286 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 907 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
287 908
909 # We're gonna need it when doing patches with a predefined patchlevel
910 eshopts_push -s extglob
911
288 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 912 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
289 # usage can be either via an env var or by params 913 # usage can be either via an env var or by params
914 # although due to the nature we pass this within this eclass
915 # it shall be by param only.
290 [ -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 916 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
917 UNIPATCH_LIST="${@}"
291 918
292 #unpack any passed tarballs 919 #unpack any passed tarballs
293 for i in ${UNIPATCH_LIST} 920 for i in ${UNIPATCH_LIST}; do
294 do
295 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ] 921 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
296 then 922 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
923 unset z
924 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
925 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
926 do z="${z}0";
927 done
928 PATCH_ORDER="${z}${STRICT_COUNT}"
929
930 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
931 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
932 unpack ${i##*/}
933 popd >/dev/null
934 else
935 pushd "${KPATCH_DIR}" >/dev/null
936 unpack ${i##*/}
937 popd >/dev/null
938 fi
939
940 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
941 else
297 extention=${i/*./} 942 extention=${i/*./}
943 extention=${extention/:*/}
944 PIPE_CMD=""
298 case ${extention} in 945 case ${extention} in
299 tbz2) PIPE_CMD="tar -xvjf";; 946 xz) PIPE_CMD="xz -dc";;
300 bz2) PIPE_CMD="tar -xvjf";;
301 tgz) PIPE_CMD="tar -xvzf";;
302 gz) PIPE_CMD="tar -xvzf";; 947 lzma) PIPE_CMD="lzma -dc";;
303 *) eerror "Unrecognized tarball compression" 948 bz2) PIPE_CMD="bzip2 -dc";;
304 die "Unrecognized tarball compression";; 949 patch*) PIPE_CMD="cat";;
950 diff) PIPE_CMD="cat";;
951 gz|Z|z) PIPE_CMD="gzip -dc";;
952 ZIP|zip) PIPE_CMD="unzip -p";;
953 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
305 esac 954 esac
306 955
307 ${PIPE_CMD} ${i} -C ${KPATCH_DIR} 1>/dev/null 956 PATCH_LEVEL=${i/*([^:])?(:)}
308 if [ $? == 0 ] 957 i=${i/:*/}
309 then 958 x=${i/*\//}
310 einfo "${i/*\//} unpacked" 959 x=${x/\.${extention}/}
960
961 if [ -n "${PIPE_CMD}" ]; then
962 if [ ! -r "${i}" ]; then
963 echo
964 eerror "FATAL: unable to locate:"
965 eerror "${i}"
966 eerror "for read-only. The file either has incorrect permissions"
967 eerror "or does not exist."
968 die Unable to locate ${i}
969 fi
970
971 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
972 unset z
973 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
974 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
975 do z="${z}0";
976 done
977 PATCH_ORDER="${z}${STRICT_COUNT}"
978
979 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
980 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
981 else
982 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
983 fi
984 fi
985 fi
986
987 # If experimental was not chosen by the user, drop experimental patches not in K_EXP_GENPATCHES_LIST.
988 if [[ "${i}" == *"genpatches-"*".experimental."* && -n ${K_EXP_GENPATCHES_PULL} ]] ; then
989 if [[ -z ${K_EXP_GENPATCHES_NOUSE} ]] && use experimental; then
990 continue
991 fi
992
993 local j
994 for j in ${KPATCH_DIR}/*/50*_*.patch*; do
995 for k in ${K_EXP_GENPATCHES_LIST} ; do
996 [[ "$(basename ${j})" == ${k}* ]] && continue 2
997 done
998 UNIPATCH_DROP+=" $(basename ${j})"
999 done
1000 else
1001 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
1002 debug-print "genpatches tarball: $tarball"
1003
1004 # check gcc version < 4.9.X uses patch 5000 and = 4.9.X uses patch 5010
1005 if [[ $(gcc-major-version) -eq 4 ]] && [[ $(gcc-minor-version) -ne 9 ]]; then
1006 # drop 5000_enable-additional-cpu-optimizations-for-gcc-4.9.patch
1007 if [[ $UNIPATCH_DROP != *"5010_enable-additional-cpu-optimizations-for-gcc-4.9.patch"* ]]; then
1008 UNIPATCH_DROP+=" 5010_enable-additional-cpu-optimizations-for-gcc-4.9.patch"
1009 fi
311 else 1010 else
312 eerror "Failed to unpack ${i}" 1011 if [[ $UNIPATCH_DROP != *"5000_enable-additional-cpu-optimizations-for-gcc.patch"* ]]; then
313 die "unable to unpack patch tarball" 1012 #drop 5000_enable-additional-cpu-optimizations-for-gcc.patch
1013 UNIPATCH_DROP+=" 5000_enable-additional-cpu-optimizations-for-gcc.patch"
1014 fi
314 fi 1015 fi
315
316 UNIPATCH_LIST="${UNIPATCH_LIST/${i}/}"
317 fi 1016 fi
318 done
319
320 #so now everything is unpacked, lets work out whats to be dropped and whats to be included.
321 for i in ${UNIPATCH_LIST}
322 do
323 extention=${i/*./}
324 PIPE_CMD=""
325 case ${extention} in
326 bz2) PIPE_CMD="bzip2 -dc";;
327 patch) PIPE_CMD="cat";;
328 diff) PIPE_CMD="cat";;
329 gz|Z|z) PIPE_CMD="gzip -dc";;
330 ZIP|zip) PIPE_CMD="unzip -p";;
331 *) UNIPATCH_EXCLUDE="${UNIPATCH_EXCLUDE} ${i}";;
332 esac
333 x=${i/*\//}
334 x=${x/\.${extention}/}
335 [ -n "${PIPE_CMD}" ] && ${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch
336 done 1017 done
337 1018
338 #populate KPATCH_DIRS so we know where to look to remove the excludes 1019 #populate KPATCH_DIRS so we know where to look to remove the excludes
339 x=${KPATCH_DIR} 1020 x=${KPATCH_DIR}
340 KPATCH_DIR="" 1021 KPATCH_DIR=""
341 for i in $(find ${x} -type d) 1022 for i in $(find ${x} -type d | sort -n); do
342 do
343 KPATCH_DIR="${KPATCH_DIR} ${i}" 1023 KPATCH_DIR="${KPATCH_DIR} ${i}"
344 done 1024 done
345 1025
1026 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
1027 # bug #272676
1028 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
1029 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
1030 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
1031 echo
1032 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
1033 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
1034 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
1035 echo
1036 fi
1037 fi
1038
346 #so now lets get rid of the patchno's we want to exclude 1039 #so now lets get rid of the patchno's we want to exclude
1040 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
347 for i in ${UNIPATCH_EXCLUDE} 1041 for i in ${UNIPATCH_DROP}; do
348 do
349 for x in ${KPATCH_DIR}
350 do
351 rm ${x}/${i}_* 2>/dev/null
352 if [ $? == 0 ]
353 then
354 einfo "Excluding Patch #${i}" 1042 ebegin "Excluding Patch #${i}"
355 einfo "From: ${x/${WORKDIR}/}" 1043 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
356 fi 1044 eend $?
357 done
358 done 1045 done
359 1046
360 # and now, finally, we patch it :) 1047 # and now, finally, we patch it :)
361 for x in ${KPATCH_DIR} 1048 for x in ${KPATCH_DIR}; do
362 do
363 for i in $(find ${x} -maxdepth 1 -iname "*.patch" -or -iname "*.diff" | sort -u) 1049 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
364 do 1050 STDERR_T="${T}/${i/*\//}"
1051 STDERR_T="${STDERR_T/.patch*/.err}"
365 1052
1053 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
1054 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
366 1055
367 PATCH_DEPTH=0 1056 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
1057
1058 ####################################################################
1059 # IMPORTANT: This is temporary code to support Linux git 3.15_rc1! #
1060 # #
1061 # The patch contains a removal of a symlink, followed by addition #
1062 # of a file with the same name as the symlink in the same #
1063 # location; this causes the dry-run to fail, filed bug #507656. #
1064 # #
1065 # https://bugs.gentoo.org/show_bug.cgi?id=507656 #
1066 ####################################################################
1067 if [[ ${PN} == "git-sources" ]] ; then
1068 if [[ ${KV_MAJOR}${KV_PATCH} -ge 315 && ${RELEASETYPE} == -rc ]] ; then
368 ebegin "Applying ${i/*\//}" 1069 ebegin "Applying ${i/*\//} (-p1)"
369 while [ ${PATCH_DEPTH} -lt 5 ] 1070 if [ $(patch -p1 --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
370 do
371 if (patch -p${PATCH_DEPTH} --dry-run -f < ${i} >/dev/null)
372 then
373 $(patch -p${PATCH_DEPTH} -f < ${i} >/dev/null)
374 if [ "$?" -eq 0 ]
375 then
376 eend 0 1071 eend 0
1072 rm ${STDERR_T}
377 break 1073 break
378 else 1074 else
379 eend 1 1075 eend 1
380 eerror "Failed to apply patch ${i/*\//}" 1076 eerror "Failed to apply patch ${i/*\//}"
1077 eerror "Please attach ${STDERR_T} to any bug you may post."
1078 eshopts_pop
1079 die "Failed to apply ${i/*\//} on patch depth 1."
1080 fi
1081 fi
1082 fi
1083 ####################################################################
1084
1085 while [ ${PATCH_DEPTH} -lt 5 ]; do
1086 echo "Attempting Dry-run:" >> ${STDERR_T}
1087 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
1088 echo "=======================================================" >> ${STDERR_T}
1089 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
1090 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH})"
1091 echo "Attempting patch:" > ${STDERR_T}
1092 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
1093 echo "=======================================================" >> ${STDERR_T}
1094 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
1095 eend 0
1096 rm ${STDERR_T}
1097 break
1098 else
1099 eend 1
381 die "Failed to apply ${i/*\//}" 1100 eerror "Failed to apply patch ${i/*\//}"
1101 eerror "Please attach ${STDERR_T} to any bug you may post."
1102 eshopts_pop
1103 die "Failed to apply ${i/*\//} on patch depth ${PATCH_DEPTH}."
382 fi 1104 fi
383 else 1105 else
384 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 1106 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
385 fi 1107 fi
386 done 1108 done
387 if [ ${PATCH_DEPTH} -eq 5 ] 1109 if [ ${PATCH_DEPTH} -eq 5 ]; then
388 then 1110 eerror "Failed to dry-run patch ${i/*\//}"
389 eend 1 1111 eerror "Please attach ${STDERR_T} to any bug you may post."
390 die "Unable to dry-run patch." 1112 eshopts_pop
1113 die "Unable to dry-run patch on any patch depth lower than 5."
391 fi 1114 fi
392
393
394 done 1115 done
395 done 1116 done
396}
397 1117
398# custom functions 1118 # When genpatches is used, we want to install 0000_README which documents
399#============================================================== 1119 # the patches that were used; such that the user can see them, bug #301478.
400detect_version() { 1120 if [[ ! -z ${K_WANT_GENPATCHES} ]] ; then
401 # this function will detect and set 1121 UNIPATCH_DOCS="${UNIPATCH_DOCS} 0000_README"
402 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 1122 fi
403 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 1123
404 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 1124 # When files listed in UNIPATCH_DOCS are found in KPATCH_DIR's, we copy it
405 1125 # to the temporary directory and remember them in UNIPATCH_DOCS to install
406 OKV=${PV/_beta/-test} 1126 # them during the install phase.
407 OKV=${OKV/_rc/-rc} 1127 local tmp
408 OKV=${OKV/_pre*/} 1128 for x in ${KPATCH_DIR}; do
409 OKV=${OKV/-r*/} 1129 for i in ${UNIPATCH_DOCS}; do
410 1130 if [[ -f "${x}/${i}" ]] ; then
411 KV_MAJOR=$(echo ${OKV} | cut -d. -f1) 1131 tmp="${tmp} ${i}"
412 KV_MINOR=$(echo ${OKV} | cut -d. -f2) 1132 cp -f "${x}/${i}" "${T}"/
413 KV_PATCH=$(echo ${OKV} | cut -d. -f3) 1133 fi
414 KV_PATCH=${KV_PATCH/[-_]*/} 1134 done
415 1135 done
416 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 1136 UNIPATCH_DOCS="${tmp}"
417 1137
418 RELEASE=${PV/${OKV}/} 1138 # clean up KPATCH_DIR's - fixes bug #53610
419 RELEASE=${RELEASE/_beta/} 1139 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
420 RELEASE=${RELEASE/_rc/-rc} 1140
421 RELEASE=${RELEASE/_pre/-bk} 1141 LC_ALL="${myLC_ALL}"
422 RELEASETYPE=${RELEASE//[0-9]/} 1142 LANG="${myLANG}"
423 1143 eshopts_pop
424 EXTRAVERSION="${RELEASE}" 1144}
425 1145
426 if [ -n "${K_PREPATCHED}" ] 1146# getfilevar accepts 2 vars as follows:
427 then 1147# getfilevar <VARIABLE> <CONFIGFILE>
428 KV="${OKV}-${PN/-*/}${PR/r/}" 1148# pulled from linux-info
1149
1150getfilevar() {
1151 local workingdir basefname basedname xarch=$(tc-arch-kernel)
1152
1153 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
1154 echo -e "\n"
1155 eerror "getfilevar requires 2 variables, with the second a valid file."
1156 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
429 else 1157 else
430 [ -z "${K_NOUSENAME}" ] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*/}" 1158 workingdir=${PWD}
431 [ ! "${PR}" == "r0" ] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 1159 basefname=$(basename ${2})
432 1160 basedname=$(dirname ${2})
433 KV=${OKV}${EXTRAVERSION} 1161 unset ARCH
1162
1163 cd ${basedname}
1164 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
1165 make ${BUILD_FIXES} -s -f - e 2>/dev/null
1166 cd ${workingdir}
1167
1168 ARCH=${xarch}
1169 fi
1170}
1171
1172detect_arch() {
1173 # This function sets ARCH_URI and ARCH_PATCH
1174 # with the neccessary info for the arch sepecific compatibility
1175 # patchsets.
1176
1177 local ALL_ARCH LOOP_ARCH COMPAT_URI i
1178
1179 # COMPAT_URI is the contents of ${ARCH}_URI
1180 # ARCH_URI is the URI for all the ${ARCH}_URI patches
1181 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
1182
1183 ARCH_URI=""
1184 ARCH_PATCH=""
1185 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
1186
1187 for LOOP_ARCH in ${ALL_ARCH}; do
1188 COMPAT_URI="${LOOP_ARCH}_URI"
1189 COMPAT_URI="${!COMPAT_URI}"
1190
1191 [[ -n ${COMPAT_URI} ]] && \
1192 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
1193
1194 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
1195 for i in ${COMPAT_URI}; do
1196 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
1197 done
434 fi 1198 fi
435 1199 done
436 # -rcXX-bkXX pulls are *IMPOSSIBLE* to support within the portage naming convention
437 # these cannot be supported, but the code here can handle it up until this point
438 # and theoretically thereafter.
439
440 if [ "${RELEASETYPE}" == "-rc" ]
441 then
442 OKV="${KV_MAJOR}.${KV_MINOR}.$([ $((${KV_PATCH} - 1)) -lt 0 ] && echo ${KV_PATCH} || echo $((${KV_PATCH} - 1)))"
443 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${PV//_/-}.bz2
444 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
445 UNIPATCH_LIST="${DISTDIR}/patch-${PV//_/-}.bz2 ${UNIPATCH_LIST}"
446 [ -n "${K_PREPATCHED}" ] && KV="${PV/[-_]*/}${EXTRAVERSION}-${PN/-*/}${PR/r/}" || KV=${PV/[-_]*/}${EXTRAVERSION}
447 fi
448
449 if [ "${RELEASETYPE}" == "-bk" ]
450 then
451 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
452 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
453 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
454 UNIPATCH_LIST="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 ${UNIPATCH_LIST}"
455 [ -n "${K_PREPATCHED}" ] && KV="${PV/[-_]*/}${EXTRAVERSION}-${PN/-*/}${PR/r/}" || KV=${PV/[-_]*/}${EXTRAVERSION}
456 fi
457
458 if [ "${RELEASETYPE}" == "-rc-bk" ]
459 then
460 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))-${RELEASE/-bk*}"
461 EXTRAVERSION="$([ -n "${RELEASE}" ] && echo ${RELEASE/*-bk/-bk})$([ -n "${K_USENAME}" ] && echo -${PN/-*/})$([ ! "${PR}" == "r0" ] && echo -${PR})"
462
463 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
464 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
465 UNIPATCH_LIST="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 ${UNIPATCH_LIST}"
466 [ -n "${K_PREPATCHED}" ] && KV="${PV/[-_]*/}${EXTRAVERSION}-${PN/-*/}${PR/r/}" || KV=${PV/[-_]*/}${EXTRAVERSION}
467 fi
468
469 S=${WORKDIR}/linux-${KV}
470} 1200}
471 1201
1202headers___fix() {
1203 # Voodoo to partially fix broken upstream headers.
1204 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1205 sed -i \
1206 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1207 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1208 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1209 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1210 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1211 "$@"
1212}
472 1213
473# common functions 1214# common functions
474#============================================================== 1215#==============================================================
475src_unpack() { 1216kernel-2_src_unpack() {
476 [ -z "${OKV}" ] && OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
477
478 cd ${WORKDIR}
479 unpack linux-${OKV}.tar.bz2
480 if [ "${OKV}" != "${KV}" ]
481 then
482 mv linux-${OKV} linux-${KV} || die "Unable to move source tree to ${KV}."
483 fi
484 cd ${S}
485
486 universal_unpack 1217 universal_unpack
487 [ -n "${UNIPATCH_LIST}" ] && unipatch ${UNIPATCH_LIST} 1218 debug-print "Doing unipatch"
1219
1220 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1221 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1222
1223 debug-print "Doing premake"
1224
1225 # allow ebuilds to massage the source tree after patching but before
1226 # we run misc `make` functions below
1227 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1228
1229 debug-print "Doing epatch_user"
1230 epatch_user
1231
1232 debug-print "Doing unpack_set_extraversion"
1233
488 [ -z "${K_NOSETEXTRAVERSION}" ] && unpack_set_extraversion 1234 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1235 unpack_fix_install_path
489 1236
490 [ $(kernel_is_2_4) $? == 0 ] && unpack_2_4 1237 # Setup xmakeopts and cd into sourcetree.
491} 1238 env_setup_xmakeopts
1239 cd "${S}"
492 1240
1241 # We dont need a version.h for anything other than headers
1242 # at least, I should hope we dont. If this causes problems
1243 # take out the if/fi block and inform me please.
1244 # unpack_2_6 should now be 2.6.17 safe anyways
1245 if [[ ${ETYPE} == headers ]]; then
1246 kernel_is 2 4 && unpack_2_4
1247 kernel_is 2 6 && unpack_2_6
1248 fi
1249
1250 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1251 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1252 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1253 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1254 fi
1255
1256 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1257 # only do this for kernel < 2.6.27 since this file does not exist in later
1258 # kernels
1259 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]] ; then
1260 sed -i \
1261 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1262 "${S}"/arch/ppc/Makefile
1263 else
1264 sed -i \
1265 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1266 "${S}"/arch/powerpc/Makefile
1267 fi
1268}
1269
493src_compile() { 1270kernel-2_src_compile() {
1271 cd "${S}"
494 [ "${ETYPE}" == "headers" ] && compile_headers 1272 [[ ${ETYPE} == headers ]] && compile_headers
495}
496 1273
1274 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1275 echo ">>> Running deblob script ..."
1276 python_setup
1277 sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1278 fi
1279}
1280
1281# if you leave it to the default src_test, it will run make to
1282# find whether test/check targets are present; since "make test"
1283# actually produces a few support files, they are installed even
1284# though the package is binchecks-restricted.
1285#
1286# Avoid this altogether by making the function moot.
1287kernel-2_src_test() { :; }
1288
497pkg_preinst() { 1289kernel-2_pkg_preinst() {
498 [ "${ETYPE}" == "headers" ] && preinst_headers 1290 [[ ${ETYPE} == headers ]] && preinst_headers
499} 1291}
500 1292
501src_install() { 1293kernel-2_src_install() {
502 install_universal 1294 install_universal
503 [ "${ETYPE}" == "headers" ] && install_headers 1295 [[ ${ETYPE} == headers ]] && install_headers
504 [ "${ETYPE}" == "sources" ] && install_sources 1296 [[ ${ETYPE} == sources ]] && install_sources
505} 1297}
506 1298
507pkg_postinst() { 1299kernel-2_pkg_postinst() {
508 [ "${ETYPE}" == "headers" ] && postinst_headers
509 [ "${ETYPE}" == "sources" ] && postinst_sources 1300 [[ ${ETYPE} == sources ]] && postinst_sources
510} 1301}
511 1302
512pkg_setup() { 1303kernel-2_pkg_setup() {
1304 if kernel_is 2 4; then
1305 if [[ $(gcc-major-version) -ge 4 ]] ; then
1306 echo
1307 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1308 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1309 ewarn "newer kernel that supports gcc-4."
1310 echo
1311 ewarn "Also be aware that bugreports about gcc-4 not working"
1312 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1313 echo
1314 epause 10
1315 fi
1316 fi
1317
1318 ABI="${KERNEL_ABI}"
513 [ "${ETYPE}" == "headers" ] && setup_headers 1319 [[ ${ETYPE} == headers ]] && setup_headers
1320 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
514} 1321}
1322
1323kernel-2_pkg_postrm() {
1324 # This warning only makes sense for kernel sources.
1325 [[ ${ETYPE} == headers ]] && return 0
1326
1327 # If there isn't anything left behind, then don't complain.
1328 [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1329 echo
1330 ewarn "Note: Even though you have successfully unmerged "
1331 ewarn "your kernel package, directories in kernel source location: "
1332 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1333 ewarn "with modified files will remain behind. By design, package managers"
1334 ewarn "will not remove these modified files and the directories they reside in."
1335 echo
1336}

Legend:
Removed from v.1.12  
changed lines
  Added in v.1.305

  ViewVC Help
Powered by ViewVC 1.1.20